## function ml_aj:model/chat/anim/display_final
## player context
## "id": The model's UUID string
## "idle": The idle anim name
## "walk": The walk anim name
## "swim": The swim anim name
## "death": The death anim name
## "despawn": The despawn anim name

function ml_aj:system/player/chat_clear

$tellraw @s [{"text":"","color":"#C29C54"},{"text":"-------------- Animations --------------\n\n"},{"text":" Idle Name:       ","hoverEvent":{"action":"show_text","contents":"The name of the idle animation that plays if the model is not moving"}},{"text":" $(idle) ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set the idle animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/idle {name:\"$(idle_text)\"}"}},{"text":"\n"},{"text":" Walk Name:       ","hoverEvent":{"action":"show_text","contents":"The name of the walk animation that plays if the model moves"}},{"text":" $(walk) ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set the walk animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/walk {name:\"$(walk_text)\"}"}},{"text":"\n"},{"text":" Swim Name:       ","hoverEvent":{"action":"show_text","contents":"The name of the swim animation that plays if the model moves in water"}},{"text":" $(swim) ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set the swim animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/swim {name:\"$(swim_text)\"}"}},{"text":"\n"},{"text":" Death Name:     ","hoverEvent":{"action":"show_text","contents":"The name of the death animation that plays if the model dies"}},{"text":" $(death) ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set the death animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/death {name:\"$(death_text)\"}"}},{"text":"\n"},{"text":" Despawn Name: ","hoverEvent":{"action":"show_text","contents":"The name of the despawn animation that plays if the model despawns (only used with the Delete despawn action set in the Save & Spawn menu)"}},{"text":" $(despawn) ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set the despawn animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/despawn {name:\"$(despawn_text)\"}"}}]

$execute if data storage ml_aj:logic data.player.temp.pet run tellraw @s [{"text":"\n","color":"#C29C54"},{"text":"-------------- Pet Model --------------\n"},{"text":" Sit Name:       ","hoverEvent":{"action":"show_text","contents":"The name of the sit animation that plays if the pet sits down"}},{"text":" $(sit) ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Click to set the sit animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/sit {name:\"$(sit_text)\"}"}},{"text":"\n"},{"text":" Sit Idle Name: ","hoverEvent":{"action":"show_text","contents":"The name of the idle animation that plays while the pet is sitting down"}},{"text":" $(sit_idle) ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Click to set the sit idle animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/sit_idle {name:\"$(sit_idle_text)\"}"}},{"text":"\n"},{"text":" Stand Name:   ","hoverEvent":{"action":"show_text","contents":"The name of the stand animation that plays if the pet stands up"}},{"text":" $(stand) ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Click to set the stand animation name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/stand {name:\"$(stand_text)\"}"}},{"text":"\n-------------------------------------"}]

$tellraw @s [{"text":"\n","color":"#C29C54"},{"text":" [Attack Animations] ","color":"dark_purple","hoverEvent":{"action":"show_text","contents":"Click to edit the attack animations"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/anim/attack/display {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Custom Animations] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to edit the custom animations that can be played using a function"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/anim/custom/display {id:\"$(id)\"}"}},{"text":"\n\n-------------------------------------\n\n"},{"text":" [Return] ","color":"#DD743B","hoverEvent":{"action":"show_text","contents":"Return to the AJ Model Editor menu"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/display {id:\"$(id)\"}"}},{"text":"\n"}]
