## function ml_aj:model/chat/display
## player context
## "id": The model's UUID string
## "badge": The model's badge id
## "name": The model name
## "variant": The model variant
## "suggest": The mob name suggest
## "auto": If the model auto reloads
## "repo": The reposition text

function ml_aj:system/player/chat_clear

$tellraw @s [{"text":"","color":"#C29C54"},{"text":"--------------- AJ Model Editor ---------------\n\n"},{"text":" Model Name:      ","hoverEvent":{"action":"show_text","contents":"The Animated Java model name"}},{"text":"$(name)","color":"yellow"},{"text":"\n"},{"text":" Custom Name:    ","hoverEvent":{"action":"show_text","contents":"The custom name to identify this specific model in the world (not required)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/name {name:'$(suggest)'}"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.mob_name","interpret":true,"hoverEvent":{"action":"show_text","contents":"Click to change the custom model name (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/name {name:'$(suggest)'}"}},{"text":"\n"},{"text":" Model Variant:  ","hoverEvent":{"action":"show_text","contents":"The variant applied to this model (Default if none) - Requires that the Include Apply Variant Functions option be checked in the Animated Java Project Settings when exporting the model"}},{"text":" [$(variant)] ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to get the command that will apply a variant to this model (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:variant {id:$(badge),name:\"$(variant)\"}"}},{"text":"\n"},{"text":" Auto Reload:    ","hoverEvent":{"action":"show_text","contents":"If this model should auto reload itself when it detects that it's outdated"}},{"text":" [$(auto)] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to Toggle"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/edit_auto {id:\"$(id)\",auto:\"$(auto)\"}"}},{"text":"\n"},{"text":" Reposition:      ","hoverEvent":{"action":"show_text","contents":"Reposition the model in the world. After starting, close the chat window and move/look around to move the model. Once finished, use the AJ Model Editor item again to stop."}},{"text":" [$(repo)] ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Click to $(repo) Repositioning"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/reposition {id:\"$(id)\",action:\"$(repo)\"}"}}]

$execute if data entity $(id) {Tags:[ml_aj.is_pet]} run tellraw @s [{"text":"","color":"#C29C54","hoverEvent":{"action":"show_text","contents":"Click to get the command that will set a player owner for this mob, making it a pet"},"clickEvent":{"action":"suggest_command","value":"/execute as @p run function ml_aj:owner {id:$(badge)}"}},{"text":" Mob Pet Owner:  "},{"text":"[","color":"white"},{"storage":"ml_aj:logic","nbt":"data.player.temp.owner","color":"white"},{"text":"]","color":"white"},{"storage":"ml_aj:logic","nbt":"data.player.temp.pet_remove","interpret":true}]
$execute if data entity $(id) {Tags:[ml_aj.is_guard]} unless data entity $(id) {Tags:[ml_aj.is_hostile]} run tellraw @s [{"text":"\n","color":"#C29C54"},{"text":" [Set Attack Target] ","color":"gray","hoverEvent":{"action":"show_text","contents":"Click to get the command that will set an entity selector for the attack target for this mob (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:target {id:$(badge),selector:'@e[limit=1,sort=nearest]'}"}},{"text":" | "},{"text":" [Remove Attack Target]","color":"dark_gray","hoverEvent":{"action":"show_text","contents":"Click to get the command that will remove the attack target from this mob"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:target_clear {id:$(badge)}"}}]

$tellraw @s [{"text":"","color":"#C29C54"},{"text":"\n------------------- Menus -------------------\n\n"},{"text":" [Model AI] ","color":"light_purple","hoverEvent":{"action":"show_text","contents":"Click to edit the AI settings for this model"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/display {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Animation] ","color":"dark_aqua","hoverEvent":{"action":"show_text","contents":"Click to edit the different animation settings for this model"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/anim/display {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Extras] ","color":"gray","hoverEvent":{"action":"show_text","contents":"Click to view additional settings for this model"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/display {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Spawn] ","color":"yellow","hoverEvent":{"action":"show_text","contents":"Click to view the Save & Spawn menu for this model"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/spawn/display {id:\"$(id)\"}"}},{"text":"\n\n--------------------------------------------\n\n"},{"text":" [Delete Model] ","color":"red","hoverEvent":{"action":"show_text","contents":"Delete this AJ Model"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/delete {id:\"$(id)\"}"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.outdated","interpret":true},{"text":"  |  "},{"text":" [Close] ","color":"#DD743B","hoverEvent":{"action":"show_text","contents":"Close this menu"},"clickEvent":{"action":"run_command","value":"/function ml_aj:system/player/chat_clear"}},{"text":"\n"}]
