## function ml_aj:model/chat/extra/display_final
## player context
## "id": The model's UUID string
## "badge": The model's badge id
## "rotation": The model rotation
## "brightness": The model brightness
## "view": The model view range
## "shadow": The shadow radius
## "shadow_opacity": The shadow opacity
## "reload_suggest": The reload callback
## "damage_suggest": The damage callback

function ml_aj:system/player/chat_clear

$tellraw @s [{"text":"","color":"#C29C54"},{"text":"-------------- Additional Settings --------------\n\n"},{"text":" Head Follows Player: ","hoverEvent":{"action":"show_text","contents":"If the model's head rotates separately from its body in order to face a nearby player (Does not work for all models)"}},{"text":" [$(rotation)] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to Toggle"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_rotation {id:\"$(id)\",rotation:\"$(rotation)\"}"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.head","interpret":true},{"text":"\n"},{"text":" Model Brightness:     ","hoverEvent":{"action":"show_text","contents":"The amount of brightness the model has (decrease past 0 to set to Auto)"}},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the model brightness"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_brightness {id:\"$(id)\",action:0}"}},{"text":"$(brightness)","color":"yellow"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the model brightness"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_brightness {id:\"$(id)\",action:1}"}},{"text":"\n"},{"text":" Model View Range:     ","hoverEvent":{"action":"show_text","contents":"The distance the model can still be viewed from (1.0 view distance = 64 blocks)"}},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the model view distance"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_view {id:\"$(id)\",action:0}"}},{"text":"$(view)","color":"yellow"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the model view distance"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_view {id:\"$(id)\",action:1}"}},{"text":"\n\n"},{"text":" Model Shadow: ","hoverEvent":{"action":"show_text","contents":"The size and opacity of the model's shadow"}},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the shadow size"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_shadow {id:\"$(id)\",shadow:$(shadow),action:0}"}},{"text":"Size $(shadow)","color":"aqua"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the shadow size"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_shadow {id:\"$(id)\",shadow:$(shadow),action:1}"}},{"text":" | "},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the shadow opacity"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_shadow_opacity {id:\"$(id)\",opacity:$(opacity),action:0}"}},{"text":"Opacity $(opacity)","color":"dark_aqua"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the shadow opacity"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/edit_shadow_opacity {id:\"$(id)\",opacity:$(opacity),action:1}"}},{"text":"\n\n"},{"text":" Reload Callback:  ","hoverEvent":{"action":"show_text","contents":"The command to run when this model is reloaded if outdated (executed as the aj.rig_root entity)"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.reload","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set a callback command (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/reload {cmd:'$(reload_suggest)'}"}},{"text":"\n"},{"text":" Health Callback:  ","hoverEvent":{"action":"show_text","contents":"The command to run when this model's health changes (executed as the aj.rig_root entity) - The model's new health value can be obtained with: data get entity @s item.tag.data.health"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.damage","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set a callback command (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/health {cmd:'$(damage_suggest)'}"}},{"text":"\n"},{"text":" Death Callback:   ","hoverEvent":{"action":"show_text","contents":"The command to run when this model dies or is deleted on despawn (executed as the aj.rig_root entity right before it's deleted from the world)"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.death","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Click to set a callback command (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/death_cb {cmd:'$(death_suggest)'}"}},{"text":"\n\n"},{"text":" [Spectate Locator] ","color":"dark_purple","hoverEvent":{"action":"show_text","contents":"Click to get the command that will set a player to spectate the locator/camera entity attached to this model, if there is one. Note: Only applies to this entity, not models spawned from this one. (When the command shows up in your chat, replace \"locator\" with the name of the locator/camera)"},"clickEvent":{"action":"suggest_command","value":"/execute as @p run function ml_aj:spectate {id:$(badge),name:\"locator\"}"}},{"text":"  |  "},{"text":" [Ride Locator] ","color":"light_purple","hoverEvent":{"action":"show_text","contents":"Click to get the command that will set a player to ride the locator/camera entity attached to this model, if there is one. Note: Only applies to this entity, not models spawned from this one. (When the command shows up in your chat, replace \"locator\" with the name of the locator/camera)"},"clickEvent":{"action":"suggest_command","value":"/execute as @p run function ml_aj:ride {id:$(badge),name:\"locator\"}"}},{"text":"\n\n--------------------------------------------\n\n"},{"text":" [Uninstall Model] ","color":"red","hoverEvent":{"action":"show_text","contents":"Uninstall the AJ Model scoreboard objectives from this world (Requires that the Include Uninstall Function be checked in your Animated Java Project Settings when exporting)"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/extra/uninstall {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Return] ","color":"#DD743B","hoverEvent":{"action":"show_text","contents":"Return to the AJ Model Editor menu"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/display {id:\"$(id)\"}"}},{"text":"\n"}]
