## function ml_aj:model/chat/vehicle/display
## player context
## "id": The model's UUID string
## "type": The mob type
## "scale": The scale size
## "speed": The mob speed
## "health": The mob health
## "bar": If the health bar is visible
## "offset": The health bar offset
## "knockback": The the mob has no knockback
## "hostile": If the mob is hostile

function ml_aj:system/player/chat_clear

$tellraw @s [{"text":"","color":"#C29C54"},{"text":"---------------- AI Settings ----------------\n\n"},{"text":" Mob Type:   ","hoverEvent":{"action":"show_text","contents":"The mob type that determines the AI for this model"}},{"text":" [$(type)] ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Click to select the mob type"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/type/display {id:\"$(id)\"}"}},{"text":"\n"},{"text":" Mob NBT:     ","hoverEvent":{"action":"show_text","contents":"The NBT data that will be applied to this mob (Note: some data may get overwritten by the system)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/nbt {nbt:$(prop_suggest)}"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.prop","hoverEvent":{"action":"show_text","contents":"Click to set the nbt data for the mob (When the command shows up in your chat, edit the value after the nbt: and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/nbt {nbt:$(prop_suggest)}"}},{"text":"\n"},{"text":" Mob Scale:  ","hoverEvent":{"action":"show_text","contents":"The scale size of the mob"}},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the scale size"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_scale {id:\"$(id)\",action:0}"}},{"text":"$(scale)","color":"yellow"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the scale size"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_scale {id:\"$(id)\",action:1}"}},{"text":" |  "},{"text":" [Visualize] ","color":"white","hoverEvent":{"action":"show_text","contents":"Click to visualize the current scale size (Note: If the mob type has not been set and confirmed yet, you won't be able to visualize the mob scale size)"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/scale_visual {id:\"$(id)\"}"}},{"text":"\n\n"},{"text":" Mob Speed: ","hoverEvent":{"action":"show_text","contents":"Set the speed of the custom mob"}},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the mob speed"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_speed {id:\"$(id)\",speed:$(speed),action:0}"}},{"text":"$(speed)","color":"yellow"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the mob speed"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_speed {id:\"$(id)\",speed:$(speed),action:1}"}},{"text":"\n"},{"text":" Mob Health: ","hoverEvent":{"action":"show_text","contents":"Set the health of the custom mob (Set to 0 to make the mob invulnerable)"}},{"text":" \u25bc ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the mob health"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_health {id:\"$(id)\",health:$(health),action:0}"}},{"text":"$(health_text)","color":"yellow"},{"text":" \u25b2 ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the mob health"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_health {id:\"$(id)\",health:$(health),action:1}"}},{"text":"\n"},{"text":" Health Bar: ","hoverEvent":{"action":"show_text","contents":"If the custom mob's health bar should be visible"}},{"text":" [$(bar)] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to Toggle"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_bar {id:\"$(id)\",bar:\"$(bar)\"}"}},{"text":" | "},{"text":" ","extra":[{"storage":"ml_aj:logic","nbt":"data.player.temp.color_text","interpret":true},{"text":" "}],"hoverEvent":{"action":"show_text","contents":"Click to set the health bar color"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_color {id:\"$(id)\"}"}},{"storage":"ml_aj:logic","nbt":"data.player.temp.offset_text","interpret":true},{"text":"\n\n"},{"text":" No Knockback:   ","hoverEvent":{"action":"show_text","contents":"If the custom mob is not pushed back by attacks"}},{"text":" [$(knockback)] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to Toggle"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_knockback {id:\"$(id)\",knockback:\"$(knockback)\"}"}},{"text":"\n"},{"text":" Is Hostile:        ","hoverEvent":{"action":"show_text","contents":"If the custom mob is hostile toward players"}},{"text":" [$(hostile)] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to Toggle"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_hostile {id:\"$(id)\",hostile:\"$(hostile)\"}"}},{"text":"\n"},{"text":" Attack Damage:  ","hoverEvent":{"action":"show_text","contents":"Set how much damage the custom mob deals when attacking an entity"}},{"text":" ◀ ","color":"green","hoverEvent":{"action":"show_text","contents":"Decrease the attack damage"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_damage {id:\"$(id)\",damage:$(damage),action:0}"}},{"text":"$(damage)","color":"yellow"},{"text":" ▶ ","color":"green","hoverEvent":{"action":"show_text","contents":"Increase the attack damage"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/edit_damage {id:\"$(id)\",damage:$(damage),action:1}"}},{"text":"\n"},{"text":" Damage Variant: ","hoverEvent":{"action":"show_text","contents":"The variant that will be applied for a short duration when the model takes damage - Requires that the Include Apply Variant Functions option be checked in the Animated Java Project Settings when exporting the model"}},{"text":" [$(d_variant)] ","color":"green","hoverEvent":{"action":"show_text","contents":"Click to set the damage variant for this model (When the command shows up in your chat, edit the value between the quotation marks, and press Enter)"},"clickEvent":{"action":"suggest_command","value":"/function ml_aj:edit/damage {name:\"$(d_variant)\"}"}},{"text":"\n\n------------------------------------------\n\n"},{"text":" [◆Confirm◆] ","color":"dark_green","hoverEvent":{"action":"show_text","contents":"Confirm AI Settings"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/confirm {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Remove AI] ","color":"red","hoverEvent":{"action":"show_text","contents":"Remove Current AI"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/remove {id:\"$(id)\"}"}},{"text":"  |  "},{"text":" [Return] ","color":"#DD743B","hoverEvent":{"action":"show_text","contents":"Return to the AJ Model Editor menu (some settings will not be saved from this menu)"},"clickEvent":{"action":"run_command","value":"/function ml_aj:model/chat/vehicle/cancel {id:\"$(id)\"}"}},{"text":"\n"}]
